10 KEY OFF: CLS
20 ' Schrodinger eq. for H. O. potential using Half-step method
30 DEF FNPOT(X) = .5*X*X     'define potential function
40 '
50 INPUT " Choose parity of state desired odd/even = ";PAR$
60 IF PAR$<>"odd" AND PAR$<>"ODD" AND PAR$<>"even" AND PAR$<>"EVEN" THEN BEEP: GOTO 50
70 INPUT "guess energy ";EGUESS
80 INPUT "Give max. x =";XMAX :PRINT
90 INPUT "step size h ";H
100 '        choose initial conditions for even/odd state
110  IF PAR$="odd" OR PAR$="ODD" THEN PSI=1 :PSI1=0
120  IF PAR$="even" OR PAR$="EVEN" THEN PSI=0 :PSI1=1
130 '
140 X=0: E=EGUESS     'inilize energy & space variable
150 '
160 WHILE ( X <XMAX  AND PSI < 10^20)
170  PSI2 = 2*(FNPOT(X+H/2)-E)*(PSI+.5*PSI1*H)   'second derivative at half step
180  PSI= PSI+(PSI1+.5*PSI2*H)*H     'new wavefunction half stepped
190  PSI1= PSI1+PSI2*H     'new first derivative of wavefunction
200  PRINT USING "x = ##.###, v(x)=###.####  psi = #.#####^^^^";X,FNPOT(X),PSI
210  X=X+H                'new position
220 WEND
230 '
240 IF PSIOLD*PSI>=0 THEN 270    'check for sign change
250 PRINT "energy lies between ";EOLD;" & ";EGUESS
260 '
270 INPUT "do you want to try another guess Y/N ";ANS$
280 IF LEFT$(ANS$,1 )<>"y" AND LEFT$(ANS$,1)<>"Y" THEN 320
290 EOLD=EGUESS: PSIOLD=PSI      'store the last result
300 CLS:GOTO 70                 'repeat for another guess
310 '
320 END
