10 CLS: KEY OFF
20 'program for correlation test using decay law
30 '
40 SCL=15                    'lattice points (row,col)
50 '
60 FOR I=1 TO SCL            'plot the lattice
70  FOR J=1 TO SCL
80    LOCATE I,J : PRINT "+"
90    VA(I,J)=1              'assign unit value to each site
100  NEXT J
110 NEXT I
120 '
130 RANDOMIZE TIMER           'feed seed
140 DECAY=0                   'initialize
150 '
160  FOR I = 1 TO NRAN STEP 2      'hitting the lattice sites
170   XG=X(I)*SCL : YG=X(I+1)*SCL  'site decided randomly
180   IF VA(XG,YG)=0 THEN 210      'site already decayed
190   VA(XG,YG)=0 :DECAY=DECAY+1   'increment decayed sites
200   LOCATE XG,YG:PRINT "o"       'change site
210 NEXT I
220 '                               hold screen
230 LOCATE 18,1:PRINT "press any key to continue"
240 IF INKEY$="" THEN 240
250 '
260 FRAC=1-DECAY/(SCL*SCL)        'find fration of surviving nuclei
270 LOGF=LOG(FRAC): DEC=NRAN/LOGF 'find decay constant
280 PRINT "fraction survived = ";FRAC
290 PRINT "decay constant = ";DEC
300 END
