10 CLS:KEY OFF                          'clear screen
20 SCREEN 1:WIDTH 40                  'change to graphic screen
30 INPUT " no of steps ";N
40 RANDOMIZE TIMER        'get a seed
50 CLS
60 LOCATE 1,5:PRINT "Brownian Motion" 'print title
70 LINE (39,9) - (251,151), ,B        'draw the container
80 X1=RND*210+40:Y1=RND *140+10       'start with random initial position
90 CIRCLE (X1,Y1),2                   'draw molecule
100 '
110  SUMD=0                             'initialize total distance
120 '
130 FOR I = 1 TO N
140    X2=RND*210+40                   'position of successive collisions
150    Y2=RND*140+10
160    DIS= SQR((X2-X1)^2+(Y2-Y1)^2)   'free path length
170    LOCATE 21,1:PRINT USING "free path in #### th collision = ###.##";I,DIS
180    LINE (X1,Y1) - (X2,Y2)          'draw the free path
190    CIRCLE (X2,Y2),2                'draw molecule
200    SUMD=SUMD+DIS                   'total distance from start
210    X1=X2:Y1=Y2                     'roll the position
220 NEXT I
230 '
240 AVDIS=SUMD/N                       'find mean free path
250 LOCATE 22,5 :PRINT "mean free path = ";AVDIS
260 '
270 END
