10 CLS:KEY OFF               'clear screen
20 'Area of an ellipse by Monte-Carlo Method
30   PI=3.1415926#
40 INPUT "no. of measurements < 50 = ";M%  :PRINT
50 INPUT "No of trials < 1000 = ";N%       :PRINT
60 INPUT "semi-major & semi-minor axes a,b = ";A,B :PRINT
70  RANDOMIZE TIMER             'give a new seed
80  SUMAR=0 :SUMARSQ=0          'initialize sum & sumsquare
90 '
100 FOR J=1 TO M%                'loop for measurements
110  COUNT%=0                    'initialize counts
120  FOR  I%= 1 TO N%            'loop for trials
130   X = A*RND: Y = B*RND       'hit a point
140   IF (X/A)^2+(Y/B)^2 <= 1 THEN COUNT% = COUNT% + 1
150         'check if the point lies within the ellipse
160  NEXT I%
170  AREA = 4*A*B*COUNT%/N%       'calculate area
180  SUMAR=SUMAR+AREA
190  SUMARSQ=SUMARSQ+AREA*AREA
200 NEXT J
210 '
220  AVAREA=SUMAR/M%     'find avearge area & St. deviation
230  SIGMA = SQR(M%*SUMARSQ - SUMAR*SUMAR)/M%
240  AA= PI*A*B                  'find exact area
250 PRINT USING "calculated area = ##.###^^^^, ";AVAREA
260 PRINT USING "Standard deviation = #.######";SIGMA
270 PRINT USING "exact area = ##.###^^^^  ";AA
280 END
