10 CLS:KEY OFF
20 'volume an ellipsoid by Monte-Carlo method
30   PI=3.1415926#
40 INPUT "no. of measurements < 50 = ";M%  :PRINT
50 INPUT "No of trials < 1000 = ";N%       :PRINT
60 INPUT "three semi-axes a,b,c = ";A,B,C  :PRINT
70  RANDOMIZE                  'give a new seed
80 SUMVO=0 :SUMVOSQ=0         'initialize sum & sum-square
90 '
100 FOR J=1 TO M%                'loop for measurements
110  COUNT%=0                    'initialize counts for each measurements
120  FOR  I%= 1 TO N%           'loop for trials
130    X = A*RND: Y = B*RND : Z=C*RND
140    IF (X/A)^2+(Y/B)^2+(Z/C)^2 <= 1 THEN COUNT% = COUNT% + 1
150    ' check if the point lies within the ellipsoid
160   NEXT I%
170   VOL = 8*A*B*C*COUNT%/N%       'calculate volume
180   SUMVO=SUMVO+VOL
190   SUMVOSQ=SUMVOSQ+VOL*VOL
200 NEXT J
210 '
220  AVVOL=SUMVO/M%             'avearge volume & st. deviation
230  SIGMA = SQR(M%*SUMVOSQ - SUMVO*SUMVO)/M%
240  EXACTVO= 4*PI*A*B*C/3         'find exact volume
250 PRINT USING "calculated volume = ##.####^^^^,";AVVOL
260 PRINT USING "Standard deviation = #.####^^^^";SIGMA
270 PRINT USING "exact area = ##.######^^^^  ";EXACTVO
280 END
