1000 ' Following program draws graph between velocity and time
1005 ' This requires N%, V(I%) and T(I%) as input array variables
1010 '
1020 SCREEN 2, 0, 0: WIDTH 80           'change screen
1030 CLS : KEY OFF                      'clear screen
1040 '
1050 DIM X%(N%), Y%(N%)                'dimension the arrays
1060                           'screen max & min coordinates
1070 SXMIN = 70: SXMAX = 570
1080 SYMIN = 20: SYMAX = 170
1090 '
1100 LINE (SXMIN, SYMAX)-(SXMAX, SYMAX) 'draw x-axis
1110 LINE (SXMIN, SYMIN)-(SXMIN, SYMAX) 'draw x-axis
1120 '
1130 LINE (60, 5)-(310, 20), , B        'draw box for heading
1140 LOCATE 2, 10: PRINT "Graph between velocity & time"
1150 LOCATE 12, 5: PRINT "V(t)"         'velocity along y axis
1160 LOCATE 23, 40: PRINT "t"           'time along x-axis
1170 '                                  'find x & y scales
1180 XMAX = TMAX: XMIN = T(0)           'max & min on x-axis
1190 YMIN = 0: YMAX = V(N%)             'max & min on y axis
1200 '          find coefficients for scale transformation
1210 K1 = (SXMAX - SXMIN) / (XMAX - XMIN)
1220 K2 = (SXMIN * XMAX - SXMAX * XMIN) / (XMAX - XMIN)
1230 K3 = (SYMIN - SYMAX) / (YMAX - YMIN)
1240 K4 = (SYMAX * YMAX - SYMIN * YMIN) / (YMAX - YMIN)
1250 '                scale transformation for  velocity & time
1260 FOR I% = 0 TO N%
1270   X%(I%) = K1 * T(I%) + K2
1280   Y%(I%) = K3 * V(I%) + K4
1290 NEXT I%
1300 '                                    'draw graph
1310 FOR I% = 1 TO N%
1320   LINE (X%(I% - 1), Y%(I% - 1))-(X%(I%), Y%(I%))  'join successive points
1330 NEXT I%
1340 '
1350 LOCATE 20, 1                        'position the cursor
1360 '
1370 END

