SCREEN 2
CLS
'Lorenz equations, Map of successive maxima only; LORMAP.BAS
DIM zi(5005), xi(5005), am(5000)', a1(500), a2(500)
'DEF fnf = (z(i + 1) - z(i))         ' difference
sig = 10: r = 24.74: b = 8 / 3             ' constants used by Lorenz
x0 = z0 = 0: y0 = 1: t0 = 0             ' initial conditions
INPUT "h,tmax=", h, tmax                ' h=.01, tmax=250
'
CLS
VIEW (10, 10)-(620, 180), , 1
WINDOW (0, 54)-(54, 25)
'LINE (0, 60)-(0, -5)
'LINE (-25, 0)-(25, 0)
'
x = x0: y = y0: z = z0: t = t0
'
FOR i = 1 TO 5000
 xp = sig * (y - x)                      ' Lorenz equations
 yp = r * x - y - x * z
 zp = x * y - b * z
 x = x + h * xp                          ' update x,y,z
 y = y + h * yp
 z = z + h * zp
' PSET (x, z)
 xi(i) = x: zi(i) = z
' PRINT "i,xi,zi=", i, xi(i), zi(i)
 t = t + h
NEXT i
'
j = 1
FOR i = 2 TO 5000
    IF (zi(i + 1) - zi(i)) < 0 AND (zi(i) - zi(i - 1)) > 0 THEN am(j) = zi(i) ELSE 500
    'PRINT "j,xi,am(j)=", j, xi(i), am(j)
    PSET (xold, am(j))
'    IF xi(i) < 0 THEN a1(j) = am(j) ELSE a2(j) = am(j)
'   PRINT "j,xi,a1,a2=", j, xi(i), a1(j), a2(j)
    xold = am(j)
    j = j + 1
500 NEXT i
'jmax = j - 1
'j = 1
'WHILE j < jmax
'PSET (am(j - 1), am(j))
'j = j + 1
'WEND
'
STOP
END




