10 KEY OFF
20 CLS
30 PRINT "*************************************************************": PRINT
40 PRINT "This program describes a motion of an object ": PRINT
50 PRINT "   thrown in the horizontal direction ": PRINT
60 PRINT "        from a certain height        ": PRINT
70 PRINT "     using Euler method": PRINT
80 'test case : vx=0,vy=12, xi=0 , yi=5, tmax=3 , h=0.1
90 PRINT "*************************************************************": PRINT
100 DIM T(500), AX(500), AY(500), VX(500), VY(500), Y(500), X(500)
110 G = -9.8                 'acceleration due to gravity, drag coefficients
120 '
130 PRINT "Give initial velocity components": PRINT
140 INPUT " Vx "; UX: PRINT
150 UY = 0                                          'nil vertical component
160 INPUT " height from which it is thrown "; YI: PRINT
170 XI = 0                                           'fix the x- origin
180 INPUT "time step  h < 0.1  = ", H: PRINT          'increment in time
190 INPUT " t max = "; TMAX: PRINT
200 '
210 N% = TMAX / H                               'find no. of steps
220 '
230  PRINT " time         Vx         Vy            X            Y      "
240  PRINT "----------------------------------------------------------"
250 VX(0) = UX: VY(0) = UY: T(0) = 0: X(0) = XI: Y(0) = YI
255 AX(0) = 0: AY(0) = G
260 FOR I = 0 TO N%
270   T(I) = H * I
280   AX(I) = AX(0)                          'nil acceleration along x-axis
290   AY(I) = AY(0)                          'fixed acceleration along y-axis
295  PRINT USING "##.###   +###.####  +###.####    +###.####  +###.####"; T(I); VX(I); VY(I); X(I); Y(I)
300   VX(I + 1) = VX(I) + AX(I) * H          'velocity formulae
310   VY(I + 1) = VY(I) + AY(I) * H
315   IF Y(I) <= 0 THEN 375
320   X(I + 1) = X(I) + VX(I) * H             'distance formulae
330   Y(I + 1) = Y(I) + VY(I) * H
350 NEXT I
355 '
365 PRINT "Object has not yet reached the ground!": GOTO 390
370 '
375  PRINT "----------------------------------------------------------"
380 PRINT "Object has reached the ground!"
390 END

