10 KEY OFF
20 CLS
30 PRINT : PRINT
40 PRINT "*************************************************************": PRINT
50 PRINT "This program describes motion of S.H.O.   ": PRINT
55 PRINT "       using Euler method": PRINT
60 'Test case : k=1, m=1, u=0, xi=1, tmax=8
70 'For large k, small m keep time interval small/ large damping
80 PRINT "*************************************************************": PRINT
90 PI = 3.1415926#
100 '
110 INPUT "spring constant & mass of the object "; K, M: PRINT
120 '
130 INPUT " initial position "; XI: PRINT
140   TLIMIT = 2 * PI / SQR(K / M)   'time period
150   W = SQR(K / M)        'omega expected
160 '
170 INPUT " initial velocity "; VI: PRINT
180 INPUT "time interval delta  0 < t < 0.1  = ", H: PRINT  'increment in time
190  PRINT USING "Give t max >  ##.###"; TLIMIT: PRINT
200 INPUT " t max = "; TMAX: PRINT
210 '
220 AC = XI: AE = VI / W      'fix A & B in general solution
230 N% = TMAX / H
240 '
250 V = VI: T = 0: S = XI    'initial conditions
260 '
270  PRINT "------------------------------------------------------------"
280  PRINT "time      velocity    position  position (exact)  total energy"
290  PRINT "------------------------------------------------------------"
300 '
310 FOR I = 1 TO N%
320 SEXACT = AE * SIN(W * T) + AC * COS(W * T)
330   ETOT = .5 * (M * V * V + K * S * S)
340  PRINT USING "##.###  +##.####  +##.#### +##.####    ##.####"; T; V; S; SEXACT; ETOT
350   T = T + H
360   S = S + V * H            'distance formula
370   V = V + A * H            'velocity formula
380   A = -K * S / M          'acceleration decrement
390 NEXT I
400  PRINT "------------------------------------------------------------"
410 '
420 END
430 '

