10 KEY OFF
16 CLS
20 PRINT :PRINT
30 PRINT "*************************************************************":PRINT
40 PRINT "This program describes motion of damped oscillations   ":PRINT
50 'Test case : k=1, m=1, u=0, xi=1, tmax=8
55 'For large k, small m keep time interval small/ large damping
60 PRINT "*************************************************************":PRINT
70 DIM T(1505),A(1505),V(1505),S(1505),S1(1505),V1(1505)
80 PI=3.1415926#
90 '
100 INPUT "spring constant & mass of the object ";K,M  :PRINT
105 INPUT "damping coefficient";C  :PRINT
110 '
120 INPUT " initial position ";XI :PRINT
130   TLIMIT=2*PI/SQR(K/M)           'time period
140 '
150 INPUT " initial velocity ";U  :PRINT
160 INPUT "time interval delta  0 < t < 0.1  = ",H :PRINT   'increment in time
170  PRINT :PRINT USING "Give t max >  ##.###";TLIMIT  :PRINT
180 INPUT " t max = ";TMAX :PRINT
190 '
200 N%=TMAX/H
210 '
220 V(0)=U :T(0)=0 :S(0)=XI           'initial conditions
222   A(0)=-(K*S(0)+C*V(0))/M                'acceleration decrement
224   V(0)=V(0)+.5*A(0)*H                  'velocity at half-step
230 FOR  I = 0 TO  N%
240   T(I)=H*I
250   S(I+1)=S(I)+V(I)*H                  'distance formula
260   A(I+1)=-(K*S(I+1)+C*V(I))/M         'acceleration decrement
270   V(I+1)=V(I)+A(I+1)*H                  'velocity formula
280   PRINT USING "t = ##.###, a = +#.####^^^^, v = +##.####^^^^  , s = +##.####^^^^";T(I),A(I),V(I),S(I)
290 NEXT I
300 '                                 'hold the screen
1000 PRINT :PRINT "press any key to continue"  :PRINT
1010 IF INKEY$="" THEN 1010
1020 '
1030 'following part draws the phase-space trajectory
1040 '
1050 SCREEN 2,0,0:WIDTH 80           'change screen
1060 CLS
1070 '
1080 LINE (70,91)-(570,91)            'draw x-axis
1090 LINE (320,11)-(320,171)          'draw x-axis
1100 LOCATE 1,10: PRINT "Phase-space trajectory"
1110             'find maxima and minima of v and s
1120  VMAX=0 :VMIN = 0: SMAX=0 : SMIN = 0
1130 '
1140 FOR I = 0 TO N%
1150   IF V(I)> VMAX THEN VMAX=V(I)
1160   IF V(I)< VMIN THEN VMIN=V(I)
1170   IF S(I)< SMIN THEN SMIN=S(I)
1180   IF S(I)> SMAX THEN SMAX=S(I)
1190 NEXT I
1200 IF ABS(VMIN) > ABS(VMAX) THEN VMAX = -VMIN ELSE VMIN = - VMAX
1210 IF ABS(SMIN) > ABS(SMAX) THEN SMAX = -SMIN ELSE SMIN = - SMAX
1220 '
1230 '                                   label the axes
1240 LOCATE 13,42:  PRINT "s(t) -->"
1250 LOCATE 9,42:  PRINT " ^  "
1260 LOCATE 10,42:  PRINT " |  "
1270 LOCATE 11,42:  PRINT "v(t)"
1280 '                                   'find scales
1290 WSCALE=500/(SMAX-SMIN)
1300 YSCALE=160/(VMAX-VMIN)
1310                        'to graph the velocity & acceleration
1320 FOR I%=0 TO N%
1330   S(I%)=S(I%)*WSCALE+320
1340   V(I%)=91-V(I%)*YSCALE
1350   IF I%>0 THEN  LINE (S(I%-1),V(I%-1))-(S(I%),V(I%))
1360 NEXT I%
1370 '
1380 END
1390 '
