10 CLS: KEY OFF        'clear screen
20 'This program describes motion of a charged particle
30 ' in CRT under Electric field
40 '
50 PI = 3.141592#
60 INPUT "Give charge & mass of the partcle ";CH,MASS  :PRINT
70 INPUT  "Give initial velocity Vx of the particle";VI :PRINT
80 INPUT "length of the plates ";L
90 INPUT "distance between the plates ";D
100 INPUT "Potentai difference between the plates ";POT
110 INPUT "maximum horizontal distance";TUBL
120 INPUT "time step ";H
130 '
140 GOSUB 1000         'to draw the electric field
150 EF =POT/D         'find electric field
160 XI=0: YI=0        'initial position x,y
170 VX=VI: VY=0       'initial velocity components
180 '
190  X=XI:Y=YI        'initialization
200 '
210   AX=0                 'no acceleration in x-direction
220   AY=CH*EF/MASS        'acceleration in y-direction
230   T=0                  'initialize time
240 '
250 WHILE X <= TUBL
260   KE= .5*MASS*(VX*VX+VY*VY)      'find K.E.
270   LOCATE 22,1
280   PRINT USING "t=###.##, KE= ####.###, X= +##.###, Y=+##.###";T,KE,X,Y
290 IF X <= L AND ABS(Y) > .5*D THEN 1100 'ssee if particle strikes plate
300  GOSUB 2010                      'draw trajectory
310   IF X > L THEN AY =0         'if particle comes out of plates
320   VY=VY+AY*H                   'Vy velocity formula
330   X=X+VX*H                     'distance formula
340   Y=Y+VY*H
350   T=T+H                        'increment time
360 WEND
370 '
380 END
390 '
1000 ' Following program draws graph between velocity and time
1010 '
1020 SCREEN 2,0,0:WIDTH 80              'change screen
1030 CLS: KEY OFF                       'clear screen
1040 LOCATE 2,10:PRINT "Particle Trajectory in Electric Field"
1050                           'screen max & min coordinates
1060 SXMIN=100:SXMAX=500
1070 SYMIN=50:SYMAX=150
1080 '
1090 XMAX=TUBL : XMIN=XI                'max & min on x-axis
1100 YMAX = .5*TUBL: YMIN =-YMAX      'max & min on y axis
1110 '          find coefficients for scale transformation
1120 K1=(SXMAX-SXMIN)/(XMAX-XMIN)
1130 K2=(SXMIN*XMAX-SXMAX*XMIN)/(XMAX-XMIN)
1140 K3=(SYMIN-SYMAX)/(YMAX-YMIN)
1150 K4=(SYMAX*YMAX-SYMIN*YMIN)/(YMAX-YMIN)
1160 '        scale transformations for plates
1170  PXL%=K1*0+K2
1180  PYL%=K3*(-.5*D)+K4
1190  PXM%=K1*L+K2
1200  PYM%=K3*(.5*D)+K4
1210 LINE (PXL%,PYL%)-(PXM%, PYL%)  'draw lower plate
1220 LINE (PXL%,PYM%)-(PXM%, PYM%)  'draw upper plate
1230 RETURN
1240 '
2000 ' subroutine to draw trajectory of charged particle
2010 '                scale transformation for  x & y
2020  X%=K1*X+K2
2030  Y%=K3*Y+K4
2040  IF X> XI THEN LINE -(X%,Y%) ELSE PSET(X%,Y%)  'join successive points
2050 RETURN
