10 CLS:KEY OFF         'clear screen
20 'Growth of current in a LR - circuit"
30  GOSUB 2070          'get inputs
40  GOSUB 1010          'draw axes & set scales
50 I=0 :T=0            'initial conditions
60 V=VI                'initialization
70  WHILE T <= TMAX    'loop over time
80    GOSUB 2010        'draw I vs. t curve
90    DI=(V-I*R)/L     'find dI/dt
100   T=T+H            'new time
110   I=I+DI*H         'current at new time
120 WEND               'loop ends
130 '
140 END
150 '
1000 'subroutine to draw x- & y- axis , to choose scales
1010 SCREEN 2,0,0:WIDTH 80         'change screen
1020 TMIN=0 :IMAX=VI/R :IMIN=0     'set limits for graphics
1030 TSCALE=500/(TMAX-TMIN) :ISCALE=150/(IMAX-IMIN)
1040 CLS
1050 LOCATE 1,10: PRINT "Current vs. time in LR - circuit"
1060 LINE (80,15)- (80,165)            'draw y-axis
1070 LINE (80,165)-(580,165)           'draw x-axis
1080 RETURN
1090 '
2000 'subroutine to graph
2010  I%=165-(I-IMIN)*ISCALE     'scale transformation
2020  T%=(T-TMIN)*TSCALE+80
2030  IF T > TMIN THEN LINE -(T%,I%) ELSE PSET(T%,I%) 'draw curve
2040 RETURN
2050 '
2060 'sub for getting inputs for growth of current in LR circuit
2070 PRINT "Please give circuit parameters in LR - Circuit":PRINT
2080 INPUT "Value of Resistance R = ";R
2090 INPUT "Value of Inductance L = ";L
2100 INPUT "Voltage applied = ";VI:PRINT
2110 INPUT "maximu time = ";TMAX
2120 INPUT "time step h = ";H
2130 RETURN
2140 '
