10 CLS                                 'clear  screen
20 'This program describes a falling object in a viscous medium
30 'assign constants pi & acceleration due to gravity
40 PI = 3.141593: G = 9.8
50                                   'give inputs of the physical system
60  INPUT "Radius and mass  of the  ball r, m  "; RAD, MASS
70  INPUT "Coefficient of viscosity  n  "; NETA
80  INPUT "Give initial veolcity and position "; VI, XI
90  INPUT "Maximum time  = ", TMAX
100 INPUT "time step = ", H             'give time step size
110 '
120 N% = TMAX / H                       'find no. of steps
130 CONSTT = 6 * PI * NETA * RAD / MASS  'calculate a constant
140 T = 0: X = XI: V = VI               'initialize the quantities
150  PRINT TAB(1); "time"; TAB(16); "acceleration";
160  PRINT TAB(31); "position"; TAB(46); "velocity"      'print heading
170 '
180 FOR I% = 1 TO N%                    'loop over time step starts
190   A = G - CONSTT * V                'replace acceleration
200  PRINT TAB(1); T; TAB(16); A; TAB(31); X; TAB(46); V
210   X = X + V * H                     'find next position
220   V = V + A * H                     'find new velocity
230   T = T + H                         'increment time
240 NEXT I%                             'loop ends
250 '
260 END                                 'program ends

