10 CLS : KEY OFF                'clear screen
20 'Double integration of f(x,y) by Simpson Rule
30 DEF FNV(X,Y)=X*Y            'change it for other choice
40 INPUT "x1,x2 = ";X1,X2      'give lower & upper limits
50 INPUT "y1,y2 = ";Y1,Y2
60 INPUT " Nx, Ny = ";N,NY     'give no. of lattice points
70 '
80 H=(X2-X1)/N : HY=(Y2-Y1)/NY 'find step size
90  SUMY=0                'initialize sum for y integration
100 FACY=2                      'a weight factor
110 '
120 FOR J = 1 TO NY-1           'loop for y integraion
130  Y= Y1+J*HY                'find y point
140  SUM=0              'initialize sum for x integration
150  FAC=2                    'weight factor
160  FOR I = 1 TO N-1         'loop for x integration
170   X= X1+I*H               'find x point
180   IF I=1 THEN SUM=SUM+3*FNV(X,Y) : GOTO 220 'first x-point
190   IF I=N-1 THEN SUM=SUM+3*FNV(X,Y) :GOTO 220 ' last x-point
200   IF FAC=2 THEN FAC=4 ELSE FAC=2   'alternate weight factor
210   SUM= SUM+FAC*FNV(X,Y)     'update the sum for x integration
220  NEXT  I
230  SUM=SUM*H/3
240  IF J=1 THEN SUMY=SUMY+3*SUM    :GOTO 280 'first y point
250  IF J=NY-1 THEN SUMY=SUMY+3*SUM :GOTO 280 'last y point
260  IF FACY=2 THEN FACY=4 ELSE FACY=2 'alternate weight factor
270  SUMY= SUMY+FACY*SUM        'update the sum for y integration
280 NEXT  J
290 '
300 SUMY=SUMY*HY/3
310 PRINT "Value of the integral = ";SUMY
320 '
330 END
