2 SCREEN 2
5  CLS
10 'CHAOS: non linear pendulum, eq of motion, a=F(x,v,t)
15 DEF Fnf (x, v, t) = -SIN(x) - c * v - f * COS(w * t)
'
INPUT "h,c,f,w = ", h, c, f, w
30 'INPUT "x, v = ", x0, v0                  'initial angular x,v
CLS
31 VIEW (10, 10)-(620, 180), , 1
WINDOW (-10, 3)-(10, -3)
LINE (0, 0)-(5, 0)
LINE (0, 3)-(0, -3)
 'v0 = v0 - .5:
'x = x0: v = v0
25 FOR v = -3 TO 3 STEP .5
x = -10
t = 0
35 PSET (x, v)
IF x > 10 THEN x = x - 20
IF x < -10 THEN x = x + 20
IF v > 3 THEN v = v - 6
IF v < -3 THEN v = v + 6
40                   'PRINT t, x, v                          '(t,x), (x,v)
50 k1 = h * Fnf(x, v, t)                   'calculate k1, k2, k3, k4
60 k2 = h * Fnf(x + h * v / 2, v + k1 / 2, t + h / 2)
70 k3 = h * Fnf(x + h * v / 2 + h * k1 / 4, v + k2 / 2, t + h / 2)
80 k4 = h * Fnf(x + h * v + h * k2 / 2, v + k3, t + h)
90 x = x + h * (v + (k1 + k2 + k3) / 6)  'update x
100 v = v + (k1 + 2 * k2 + 2 * k3 + k4) / 6    'update v
110 t = t + h                            'increment time
'IF t > 1000 THEN 140
120 IF INKEY$ <> "" THEN 130 ELSE 35
'130 GOTO 32
130 NEXT v
140 END




