SCREEN 2
CLS
'Lorenz equations, Butterfly, LOR.BAS
sig = 10: r = 28: b = 8 / 3             ' constants used by Lorenz
x = z = 0: y = 1                        ' initial conditions
INPUT "h,tmax=", h, tmax                ' h=.001, t=10
CLS
VIEW (10, 10)-(620, 180), , 1
WINDOW (-25, 60)-(25, -5)
LINE (0, 60)-(0, -5)
LINE (-25, 0)-(25, 0)
100 PSET (x, z)
xp = sig * (y - x)                      ' Lorenz equations
yp = r * x - y - x * z
zp = x * y - b * z
x = x + h * xp                          ' update x,y,z
y = y + h * yp
z = z + h * zp
t = t + h                               ' time increment
'PRINT r
IF t > tmax THEN 200 ELSE 100
200 STOP
END




