10 'This Program shows standing waves
20 CLS:KEY OFF
30 PI=3.141592
40                               'define resultant amplitude
50 DEF FNF(X,T)=SIN(2*PI*(X-V*T)/LAM)+SIN(2*PI*(X+V*T)/LAM)
60 '
70  INPUT "Give wavelength & velocity of the wave ";LAM,V
80  INPUT "Give Xmax ";XMAX
90 '
100  TP = LAM/V                  'find time period
110 XMIN=0:T=0                  'initialize position & time
120 H=.05: HT=.05               'step size for x & t variables
130  GOSUB 1000                  'draw base line
140 '
150 WHILE T <=TP                'start loop over time
160   X= XMIN                   'initilize position
170   GOSUB 2020                 'start new instant
180   WHILE X <= XMAX             'loop over space points
190     Y = FNF(X,T)              'find resultant amplitude
200     GOSUB 3020                 'draw standing wave
210     X=X+H                     'increment x
220   WEND                        'loop over x ends
230   T=T+HT                    'increment time
240  WEND                       'loop over time ends
250 '
260 END
270 '
280 'subroutine to draw axes of the graph
290 '
1000 SCREEN 2,0,0:WIDTH 80       'change screen
1010 YMIN=-2:YMAX=2              'set y-limits for grpahics
1020  XSCALE=500/(XMAX-XMIN)     'scales for x- & y-axes
1030 YSCALE=150/(YMAX-YMIN)
1040 CLS
1050 LOCATE 1,10:PRINT "Standing Waves"  'print title
1060 LINE (40,83) - (540,83)             'draw base line
1070 RETURN
1080 '
2000 'subroutine to start wave at the new instant
2010 '
2020 X1%=XMIN*XSCALE+40              'initial point
2030 Y1%=(YMAX-FNF(XMIN,T))*YSCALE+8
2040 PSET(X1%,Y1%)                   'draw initial point
2050  BEEP                           'beep for new intant
2060 LOCATE 1,50 :PRINT USING "t = ##.##";T 'print current time
2070 RETURN
2080 '
3000 'subroutine to draw wave amplitude
3010                     'scale transformation
3020 X2%=X*XSCALE+40
3030 Y2%=(YMAX-Y)*YSCALE+8
3040  LINE -(X2%,Y2%)    'join with last point
3050 RETURN
3060 '
