10 'This program shows Modulation of a Wave
20 '
30 CLS:KEY OFF
40 '
50 PI=3.141592
60  'define resultant amplitude function for two waves
70 DEF FNF(X,T)=A1*SIN(2*PI*(X-V1*T)/LAM1+ PHASE)+A2*SIN(2*PI*(X-V2*T)/LAM2)
80 INPUT "amplitude, wavelength & velocity of first wave";A1,LAM1,V1
90 PRINT
100 INPUT "amplitude, wavelength & velocity of second wave";A2,LAM2,V2
110 PRINT
120 INPUT "phase of first wave w.r.t second  = ";PHASE  :PRINT
130 INPUT "tmax, xamx ";TMAX,XMAX
140 '
150 XMIN=0:T=0             'initialize time & space point
160 H=.1: HT=.5                    'step sizes
170 '
180 GOSUB 1020                     'draw axes
190 '
200 WHILE T < TMAX                 'loop over time
210  X= XMIN                       'initialize position
220  GOSUB 2020                    'clear the box
230  WHILE X < XMAX                  'loop over space points
240    Y = FNF(X,T)                  'find resultant amplitude
250    GOSUB 3020                    'draw modulated wave
260    X=X+H                         'next space point
270  WEND                            'loop over x ends
280  T=T+HT                        'increment time
290 WEND                           'loop over time ends
300 '
310 END                              'program ends
320 '
1000 'subroutine to draw axes of the graph
1010 '
1020 SCREEN 2,0,0:WIDTH 80:CLS    'change screen for graphics
1030 YMAX=A1+A2 : YMIN=-YMAX      'max & min for graphics
1040 XSCALE=500/(XMAX-XMIN)       'scales for x- & y-axes
1050 YSCALE=150/(YMAX-YMIN)
1060 LINE (41,83)-(539,83)        'draw base line
1070 LOCATE 1,10:PRINT "Modulated Wave" 'print title
1080 RETURN
1090 '
2000 'subroutine to clear screen
2010 '
2020 LINE (41,9)-(539,82), 0, BF    'clear  box
2030 LINE (41,84)-(539,157), 0, BF
2040 X1%=XMIN*XSCALE+40             'first space point
2050 Y1%=(YMAX-FNF(XMIN,T))*YSCALE+8
2060 BEEP                    'beep for new time instant
2070 LOCATE 3,10 :PRINT USING "t = ##.##";T 'print time
2080 '
2090 RETURN
2100 '
3000 'subroutine to draw modulated wave
3010  '                   scale transformation for x- & y-axes
3020 X2%=X*XSCALE+40                 'current point
3030 Y2%=(YMAX-Y)*YSCALE+8
3040 IF X> XMIN THEN LINE (X1%,Y1%)-(X2%,Y2%)
3050 X1%=X2% : Y1%=Y2%         'roll the values
3060 '
3070 RETURN
3080 '
