10 CLS:KEY OFF
20 'Polariztion in medium with
30 'different refractive indices in x,y directions
40 PI=3.141592
50 ' define amplitude fnction
60 DEF FNF(A,X,T,P)=A*SIN(KV*X-WF*T-P*PI/180)
70 '
80  INPUT "wave vector & frequency the light = ";KV,WF
90  INPUT "Electric Field components Ex, Ey ";EXI, EYI
100 INPUT "phases of x,y components = ";PHX,PHY
110 INPUT "width of crystal = ";WID
120 INPUT "refractive indices along x,y direction ";NX,NY
130 INPUT "tmax ";TMAX
140 '
150 X=0:T=0                  'initialize time and x
160 H=.1                     'time step
170 GOSUB 1020                'draw axes
180 '
190 WHILE T < TMAX          'loop over time steps
200  X=WID                  'use x=0 or x=wid
210  EX=FNF(EXI,X,T,PHX)    'find x components
220  EY=FNF(EYI,X,T,PHY)   'find y components
230   X=WID/NX              'effective width along x axis
240   EX1=FNF(EXI,X,T,PHX)  'find x component
250   X=WID/NY              'effective width along y axis
260   EY1=FNF(EYI,X,T,PHY)  'find y compnents
270   GOSUB 2010             'draw field vector
280  T=T+H                  'increment time
290 WEND
300 '
310 END
320 '
1000 'subroutine to draw axes of the graph
1010 '
1020 SCREEN 2,0,0:WIDTH 80:CLS       'change screen for graphics
1030 LOCATE 1,25:PRINT "Electric Field Vector"
1040 LOCATE 2,10::PRINT "Vacuum"
1050 IF EXI>= EYI THEN MAX= EXI ELSE MAX=EYI 'find limits for field vector
1060 EXMAX=MAX:EXMIN=-EXMAX
1070 EYMAX=MAX:EYMIN=-EYMAX
1080 YSCALE=80/(EYMAX-EYMIN)         'find y-scale
1090  XSCALE=YSCALE*2.5     'find x-scale: aspect ratio 2.5
1100 XBEG%=64 : YBEG%=16
1110 XL%=(EXMIN-EXMIN)*XSCALE+XBEG%  'corners of first diagram
1120 YM%=(EYMAX-EYMIN)*YSCALE+YBEG%
1130 XM%=(EXMAX-EXMIN)*XSCALE+XBEG%
1140 YL%=(EYMAX-EYMAX)*YSCALE+YBEG%
1150 XH%=.5*(XL%+XM%)                'coordinates of origin
1160 YH%=.5*(YL%+YM%)
1170  LINE (XL%,YH%)-(XM%,YH%)  'draw x,y axes
1180  LINE (XH%,YL%)-(XH%,YM%)
1190 '
1200 LOCATE 2,50 :PRINT "Birefringence"
1210 '
1220 XBEG1%=364 : YBEG1%=16
1230 XL1%=(EXMIN-EXMIN)*XSCALE+XBEG1%
1240 YM1%=(EYMAX-EYMIN)*YSCALE+YBEG1%
1250 XM1%=(EXMAX-EXMIN)*XSCALE+XBEG1%
1260 YL1%=(EYMAX-EYMAX)*YSCALE+YBEG1%
1270 XH1%=.5*(XL1%+XM1%)
1280 YH1%=.5*(YL1%+YM1%)
1290  LINE (XL1%,YH1%)-(XM1%,YH1%)
1300  LINE (XH1%,YL1%)-(XH1%,YM1%)
1310 RETURN
1320 '
2000 'subroutine to draw electric vector
2010 LOCATE 20,30:PRINT USING "current time ###.###";T
2020  '                             scale transformation
2030 X%=(EX-EXMIN)*XSCALE+XBEG%     'for incoming wave
2040 Y%=(EYMAX-EY)*YSCALE+YBEG%
2050 X1%=(EX1-EXMIN)*XSCALE+XBEG1%  'for outgoing wave
2060 Y1%=(EYMAX-EY1)*YSCALE+YBEG1%
2070 '
2080 LINE (XH%,YH%)-(X%,Y%)      'draw incoming E-vector
2090 LINE (XH1%,YH1%)-(X1%,Y1%)  'draw outgoing E-vector
2100 RETURN
