10 KEY OFF : CLS              'clear screen
20 SCREEN 2,0,0:WIDTH 80      'change screen
30 '
40 INPUT "k, Q";K,Q           'give constant k and charge
50 PRINT "Electric Field due to a point charge"
60 '
70 X1=300: Y1=100            'location of charge Q
80 XMAX=550:YMAX=180 : XMIN=50:YMIN=20  'set graphics
90 D=10                       'set dimension of squares
100 MX=(XMAX-XMIN)/D: MY=(YMAX-YMIN)/D 'find grid structure
110 '
120  FOR K=1 TO MY             'loop over y-axis
130    Y=YMIN+(K-.5)*D        'find current y
140    FOR J=1 TO MX          'loop over x axis
150      X=XMIN+(J-.5)*D      'find current x
160      XD=(X-X1): YD=(Y-Y1) 'find distance components
170      R=SQR(XD^2+YD^2)     'find distance
180      EX=K*Q*XD/R^3
190      EY=K*Q*YD/R^3        'find field components
200      E=SQR(EX*EX+EY*EY)   'find field magnitude
210      NX=EX*D/E:NY=EY*D/E  'scale field components
220      LINE (X-.5*NX,Y-.5*NY)-(X+.5*NX, Y+.5*NY) 'draw line
230   NEXT J
240 NEXT K
250 '
260 END
