10 KEY OFF : CLS       'clear screen
20 PRINT "This program maps Electric Field due to N point-charges"
30 INPUT " no. of charges = ";N
40 PRINT "Give the location of charges with in the following bounds"
50 PRINT "  100 < x <540 , 30 < y < 170"
60 '
70 FOR I=1 TO N
80   PRINT "charge No. ";I
90   INPUT "Give charge & position q, x, y ";Q(I), X(I),Y(I)
100 NEXT  I
110 '
120  XMAX=540:YMAX=170 :XMIN=100:YMIN=30    'boundary of mapping
130  INPUT "give dx & dy ";DX,DY            'dimensions of squares
140  MX=(XMAX-XMIN)/DX : MY=(YMAX-YMIN)/DY  'find grid pattern
150 '
160 CLS                                    'claer screen, print title
170 LOCATE 1,15 :PRINT " Electric Field due to ";N;" point-charges"
180 FOR K=1 TO MY                            'loop over y-direction
190   Y=YMIN+(K-.5)*DY                       'find  y component
200   FOR J=1 TO MX                          'loop for x-direction
210      X=XMIN+(J-.5)*DX                    'find x component
220      ETX=0:ETY=0                         'initialization of field
230      FOR I=1 TO N                        'loop over charges
240        XD=(X-X(I)): YD=(Y-Y(I))
250        R=SQR(XD^2+YD^2)                  'find distance fronm charge i
260        EX=Q(I)*XD/R^3:EY=Q(I)*YD/R^3     'field components
270        ETX=ETX+EX:ETY=ETY+EY             'update field components
280      NEXT I
290      EF=SQR(ETX*ETX+ETY*ETY)              'magnitude of field
300      NX=ETX*DX/EF : NY=ETY*DY/EF             'directing the field vector
310      LINE (X-.5*NX,Y-.5*NY) - (X+.5*NX, Y+.5*NY)
320   NEXT J
330 NEXT K
340 '
350 END
