10 KEY OFF : CLS    'clear screen
20 SCREEN 2,0,0:WIDTH 80
30 PRINT "this program draws equipotential surfaces due to N - Charges":PRINT
40 '
50  XMAX=540:YMAX=170 : XMIN=40:YMIN=30         'boundary of mapping
60 INPUT " no. of charges = ";N
70 DIM Q(N),X(N),Y(N)
80 PRINT "Give the location of charges with in the following bounds"
90 PRINT XMIN ;" < x < ";XMAX;" , ";YMIN ;" < y < ";YMAX
100 '
110 FOR I=1 TO N
120   PRINT "charge no. ";I
130   INPUT " Give charge & its position q, x, y ";Q(I), X(I),Y(I)
140 NEXT  I
150 '
160 CLS
170 LOCATE 1,15 :PRINT "Equipotential surfaces due to";N;"-point charges"
180 '
190 FOR I= 1 TO N             'loop for locating charges
200   Y%=X(I)/8
210   X%=Y(I)/8
220   LOCATE X%,Y%:IF Q(I)>0 THEN PRINT "+" ELSE PRINT "-"
230 NEXT I
240 '
250  MX=20:  MY=20                          'no of steps
260  DX=(XMAX-XMIN)/MX : DY=(YMAX-YMIN)/MY  'dimensions of grid box
270 '
280 FOR K=1 TO MY                          'loop for y axis
290   Y=YMIN+(K-.5)*DY                     'find y component
300   FOR J=1 TO MX                        'loop for x axis
310     X=XMIN+(J-.5)*DX                   'find x component
320     SEX=0 : SEY=0                      'initialization of field
330     FOR I=1 TO N                       'loop over charges
340        XD=(X-X(I)): YD=(Y-Y(I))
350        R=SQR(XD^2+YD^2)                'find distance
360        EX=Q(I)*XD/R^3:EY=Q(I)*YD/R^3   'field components
370        SEX=SEX+EX : SEY=SEY+EY         'update total field
380      NEXT I
390      EF=SQR(SEX*SEX+SEY*SEY)            'magnitude of field
400      NX=-SEY*DX/EF : NY=SEX*DY/EF       'direction of equipot. surface
410      LINE ((X-.5*NX),Y-.5*NY) - ((X+.5*NX), Y+.5*NY) 'draw line
420   NEXT J
430 NEXT K
440 '
450 END
