10 CLS:KEY OFF
20 PRINT "Currents in a circuit using Kirchoff laws":PRINT
30 '
40 INPUT "give no. of current elements = ";SIZMAT :PRINT
50 DIM ORMAT(SIZMAT,SIZMAT),INMAT(SIZMAT,SIZMAT),C(SIZMAT),RHS(SIZMAT)
60 '                              give dimensions of arrays
70 PRINT "give coefficients in the equations " :PRINT
80  FOR ROW = 1 TO SIZMAT        'loop over rows
90    PRINT "equation no. = ";ROW :PRINT
100    FOR COL = 1 TO SIZMAT      'loop over columns
110      PRINT "give coefficients (";ROW;",";COL;")"
120     INPUT ORMAT(ROW,COL)      'give matrix elements
130   NEXT COL
140   PRINT
150 NEXT ROW
160 '
170 PRINT "give r.h.s values in the equations " :PRINT
180  FOR ROW = 1 TO SIZMAT         'loop over rows
190    PRINT "equation no. = ";ROW :PRINT
200     INPUT RHS(ROW)
210 NEXT ROW
220 '       find inverse of the matrix
230 FOR ROW=1 TO SIZMAT      'start with a identity matrix
240  INMAT(ROW,ROW)=1
250 NEXT ROW
260 '
270 FOR S=1 TO SIZMAT         'loop over rows
280   GOSUB 1020              'use subroutine
290 NEXT S
300 '                           find current elements
310 FOR ROW=1 TO SIZMAT        'loop over rows
320   SUM=0
330   FOR COL = 1 TO SIZMAT
340     SUM=SUM + INMAT(ROW,COL)*RHS(COL)
350   NEXT COL
360   PRINT "current elment I(";ROW;") = ";SUM :PRINT
370 NEXT ROW
380 '
390 END
400 '
1000 ' subroutine to find inverse of the matrix involved
1010 '          find the greatest element in the chosen row
1020 FOR J = S TO SIZMAT  'loop over columns >= chosen row
1030  C(J)=ABS(ORMAT(J,S)) 'choose the element in that row
1040 NEXT J
1050 '
1060 J = S                     'identify with chosen row
1070 FOR K = J TO SIZMAT 'start a loop over columns to compare
1080  IF C(J)<C(K) THEN 1130  'column whose element is greater
1090 NEXT K
1100 '
1110 GOTO 1150 'jump over next step when largest element found
1120 '
1130 J=K:GOTO 1070    'identify it with that column & continue
1140 '
1150 IF C(J)=0 THEN PRINT "no solution":END 'matrix is singular
1160 '
1170 FOR K=1 TO SIZMAT         'loop over columns
1180  X=ORMAT(S,K):Y=INMAT(S,K)  'kkep in memory
1190  ORMAT(S,K)=ORMAT(J,K):INMAT(S,K)=INMAT(J,K)
1200  ORMAT(J,K)=X:INMAT(J,K)=Y 'exchange the elements in rows J & S
1210 NEXT K
1220 '
1230 D=ORMAT(S,S)   'pickup diagonal element of he chosen row
1240 '
1250 FOR J= 1 TO SIZMAT        'loop over columns
1260  ORMAT(S,J)=ORMAT(S,J)/D  'divide by diagonal element
1270  INMAT(S,J)=INMAT(S,J)/D  'do the same here too
1280 NEXT J
1290 '
1300 FOR J=1 TO SIZMAT
1305   IF J=S THEN 1360      'avoid if col = row (chosen)
1310   M=ORMAT(J,S)
1320   FOR K= 1 TO SIZMAT  'subtract after proper multiplication
1330     ORMAT(J,K)=ORMAT(J,K)-M*ORMAT(S,K)
1340     INMAT(J,K)=INMAT(J,K)-M*INMAT(S,K)
1350   NEXT K
1360 NEXT J
1370 '
1380 RETURN
1390 '
