10 CLS: KEY OFF
20 'This Program describes Charging/Dioscharging  of a Capacitor
30  GOSUB 1010            'get inputs
40  GOSUB 2000            'draw axis & set scales
50 '
60 T=TMIN:Q=QI:V=VI      'initialization
70 '
80  WHILE T <=TMAX       'loop over time starts
90   GOSUB 3000           'draw charge
100   I=(V-Q/C)/R         'find dq/dt
110  T=T+H               'new time
120  Q=Q+I*H             'charge at new time
130 WEND                 'loop ends
140 '
150 END                  'main program ends
160 '
1000 'subroutine to get inputs
1010 PRINT "Please give RC- circuit parameters":PRINT
1020 INPUT "Value of Resistance R = ";R
1030 INPUT "Value of Capacitance C = ";C
1040 INPUT "maximum time = ";TMAX
1050 INPUT "time step h = ";H :PRINT
1060 '                         menu selection
1070 PRINT "Please make yoour choice .... ":PRINT
1080 PRINT "1. Charging of the capacitor "
1090 PRINT "2. Discharging of the capacitor ":PRINT
1100 INPUT "choice 1 or 2 = "; CH%
1110 PRINT
1120 ON CH%  GOSUB 1505,1605
1130 RETURN
1140 '
1500 'sub for getting inputs for charging of a capacitor
1505 PRINT "    for charging the capacitor"
1510 INPUT "Give voltage of the battery applied = ";VI
1515 QI=0 :TMIN =0               'initial conditions fixed
1520 QMAX=C*VI: QMIN=0           'set limits for graphics
1525 RETURN
1530 '
1600 'sub for getting inputs for discharging of a capacitor
1605 PRINT "    for discharging the capacitor"
1610 INPUT "Charge on the capacitor Q =" ;QI
1615 QMAX=QI : QMIN=0             'set limits for graphics
1620 VI=0                         'no external source
1625 RETURN
1630 '
2000 'subroutine to draw x- & y- axis , to choose scales
2010 SCREEN 2,0,0:WIDTH 80
2020 QSCALE=150/(QMAX-QMIN) :TSCALE=500/(TMAX-TMIN)
2030 CLS                         'clear screen
2040 LINE (80,15)- (80,165)             'draw y-axis
2050 LINE (80,165)-(580,165)           'draw x-axis
2060 LOCATE 10,55:PRINT "q(t) vs. t"
2070 '
2080 RETURN
2090 '
3000 'subroutine to graph
3010  Q2%=165-(Q-QMIN)*QSCALE  'scale transformations
3020  T2%=(T-TMIN)*TSCALE+80
3030  IF T>TMIN THEN LINE (T1%,Q1%)-(T2%,Q2%) 'draw curve
3040  T1%= T2%: Q1%=Q2%        'roll values
3050 '
3060 RETURN
3070 '
